diff --git a/hw/xquartz/X11Application.m b/hw/xquartz/X11Application.m
index 752ddc3f6..0b1335553 100644
--- a/hw/xquartz/X11Application.m
+++ b/hw/xquartz/X11Application.m
@@ -34,8 +34,9 @@
 #include <dix-config.h>
 #endif
 
+#include "quartzCommon.h"
+
 #import "X11Application.h"
-#import "NSUserDefaults+XQuartzDefaults.h"
 
 #include "darwin.h"
 #include "quartz.h"
@@ -47,6 +48,7 @@
 
 #include <mach/mach.h>
 #include <unistd.h>
+#include <AvailabilityMacros.h>
 
 #include <pthread.h>
 
@@ -56,13 +58,17 @@
 extern int
 xpbproxy_run(void);
 
+#define DEFAULTS_FILE X11LIBDIR "/X11/xserver/Xquartz.plist"
+
 #ifndef XSERVER_VERSION
 #define XSERVER_VERSION "?"
 #endif
 
+#ifdef HAVE_LIBDISPATCH
 #include <dispatch/dispatch.h>
 
 static dispatch_queue_t eventTranslationQueue;
+#endif
 
 #ifndef __has_feature
 #define __has_feature(x) 0
@@ -83,7 +89,11 @@
 extern Bool noTestExtensions;
 extern Bool noRenderExtension;
 
+#if MAC_OS_X_VERSION_MIN_REQUIRED >= 1050
 static TISInputSourceRef last_key_layout;
+#else
+static KeyboardLayoutRef last_key_layout;
+#endif
 
 /* This preference is only tested on Lion or later as it's not relevant to
  * earlier OS versions.
@@ -100,6 +110,8 @@
 
 X11Application *X11App;
 
+CFStringRef app_prefs_domain_cfstr = NULL;
+
 #define ALL_KEY_MASKS (NSShiftKeyMask | NSControlKeyMask | \
                        NSAlternateKeyMask | NSCommandKeyMask)
 
@@ -156,10 +168,6 @@ @interface X11Application (Private)
 - (void) sendX11NSEvent:(NSEvent *)e;
 @end
 
-@interface X11Application ()
-@property (nonatomic, readwrite, assign) OSX_BOOL x_active;
-@end
-
 @implementation X11Application
 
 typedef struct message_struct message;
@@ -169,14 +177,72 @@ @implementation X11Application
     NSObject *arg;
 };
 
+static mach_port_t _port;
+
 /* Quartz mode initialization routine. This is often dynamically loaded
    but is statically linked into this X server. */
 Bool
 QuartzModeBundleInit(void);
 
+static void
+init_ports(void)
+{
+    kern_return_t r;
+    NSPort *p;
+
+    if (_port != MACH_PORT_NULL) return;
+
+    r = mach_port_allocate(mach_task_self(), MACH_PORT_RIGHT_RECEIVE, &_port);
+    if (r != KERN_SUCCESS) return;
+
+    p = [NSMachPort portWithMachPort:_port];
+    [p setDelegate:NSApp];
+    [p scheduleInRunLoop:[NSRunLoop currentRunLoop] forMode:
+     NSDefaultRunLoopMode];
+}
+
+static void
+message_kit_thread(SEL selector, NSObject *arg)
+{
+    message msg;
+    kern_return_t r;
+
+    msg.hdr.msgh_bits = MACH_MSGH_BITS(MACH_MSG_TYPE_MAKE_SEND, 0);
+    msg.hdr.msgh_size = sizeof(msg);
+    msg.hdr.msgh_remote_port = _port;
+    msg.hdr.msgh_local_port = MACH_PORT_NULL;
+    msg.hdr.msgh_reserved = 0;
+    msg.hdr.msgh_id = 0;
+
+    msg.selector = selector;
+    msg.arg = [arg retain];
+
+    r = mach_msg(&msg.hdr, MACH_SEND_MSG, msg.hdr.msgh_size,
+                 0, MACH_PORT_NULL, 0, MACH_PORT_NULL);
+    if (r != KERN_SUCCESS)
+        ErrorF("%s: mach_msg failed: %x\n", __FUNCTION__, r);
+}
+
+- (void) handleMachMessage:(void *)_msg
+{
+    message *msg = _msg;
+
+    [self performSelector:msg->selector withObject:msg->arg];
+    [msg->arg release];
+}
+
+- (void) set_controller:obj
+{
+    if (_controller == nil) _controller = [obj retain];
+}
+
 - (void) dealloc
 {
-    self.controller = nil;
+    if (_controller != nil) [_controller release];
+
+    if (_port != MACH_PORT_NULL)
+        mach_port_deallocate(mach_task_self(), _port);
+
     [super dealloc];
 }
 
@@ -206,12 +272,10 @@ - (void) orderFrontStandardAboutPanel: (id) sender
 
 - (void) activateX:(OSX_BOOL)state
 {
-    OSX_BOOL const x_active = self.x_active;
-
-    if (x_active == state)
+    if (_x_active == state)
         return;
 
-    DEBUG_LOG("state=%d, x_active=%d, \n", state, x_active);
+    DEBUG_LOG("state=%d, _x_active=%d, \n", state, _x_active);
     if (state) {
         if (bgMouseLocationUpdated) {
             DarwinSendPointerEvents(darwinPointer, MotionNotify, 0,
@@ -235,7 +299,7 @@ - (void) activateX:(OSX_BOOL)state
         DarwinSendDDXEvent(kXquartzDeactivate, 0);
     }
 
-    self.x_active = state;
+    _x_active = state;
 }
 
 - (void) became_key:(NSWindow *)win
@@ -247,14 +311,14 @@ - (void) sendEvent:(NSEvent *)e
 {
     /* Don't try sending to X if we haven't initialized.  This can happen if AppKit takes over
      * (eg: uncaught exception) early in launch.
+     * aquaMenuBarHeight is just a proxy for initialization.
      */
-    if (!eventTranslationQueue) {
+    if (!aquaMenuBarHeight) {
         [super sendEvent:e];
         return;
     }
 
     OSX_BOOL for_appkit, for_x;
-    OSX_BOOL const x_active = self.x_active;
 
     /* By default pass down the responder chain and to X. */
     for_appkit = YES;
@@ -267,18 +331,16 @@ - (void) sendEvent:(NSEvent *)e
     case NSLeftMouseUp:
     case NSRightMouseUp:
     case NSOtherMouseUp:
-    case NSScrollWheel:
-
         if ([e window] != nil) {
             /* Pointer event has an (AppKit) window. Probably something for the kit. */
             for_x = NO;
-            if (x_active) [self activateX:NO];
+            if (_x_active) [self activateX:NO];
         }
         else if ([self modalWindow] == nil) {
             /* Must be an X window. Tell appkit windows to resign main/key */
             for_appkit = NO;
 
-            if (!x_active && quartzProcs->IsX11Window([e windowNumber])) {
+            if (!_x_active && quartzProcs->IsX11Window([e windowNumber])) {
                 if ([self respondsToSelector:@selector(_setKeyWindow:)] && [self respondsToSelector:@selector(_setMainWindow:)]) {
                     NSWindow *keyWindow = [self keyWindow];
                     if (keyWindow) {
@@ -352,11 +414,14 @@ - (void) sendEvent:(NSEvent *)e
                     swallow_keycode = [e keyCode];
                     do_swallow = YES;
                     for_x = NO;
-                } else if (XQuartzEnableKeyEquivalents &&
+#if XPLUGIN_VERSION >= 1
+                }
+                else if (XQuartzEnableKeyEquivalents &&
                          xp_is_symbolic_hotkey_event([e eventRef])) {
                     swallow_keycode = [e keyCode];
                     do_swallow = YES;
                     for_x = NO;
+#endif
                 }
                 else if (XQuartzEnableKeyEquivalents &&
                          [[self mainMenu] performKeyEquivalent:e]) {
@@ -419,7 +484,7 @@ - (void) sendEvent:(NSEvent *)e
         case NSApplicationActivatedEventType:
             for_x = NO;
             if ([e window] == nil && x_was_active) {
-                BOOL order_all_windows = YES;
+                BOOL order_all_windows = YES, workspaces, ok;
                 for_appkit = NO;
 
 #if APPKIT_APPFLAGS_HACK
@@ -432,9 +497,26 @@ - (void) sendEvent:(NSEvent *)e
                 [self set_front_process:nil];
 
                 /* Get the Spaces preference for SwitchOnActivate */
-                BOOL const workspaces = [NSUserDefaults.dockDefaults boolForKey:@"workspaces"];
+                (void)CFPreferencesAppSynchronize(CFSTR("com.apple.dock"));
+                workspaces =
+                    CFPreferencesGetAppBooleanValue(CFSTR("workspaces"),
+                                                    CFSTR(
+                                                        "com.apple.dock"),
+                                                    &ok);
+                if (!ok)
+                    workspaces = NO;
+
                 if (workspaces) {
-                    order_all_windows = [NSUserDefaults.globalDefaults boolForKey:@"AppleSpacesSwitchOnActivate"];
+                    (void)CFPreferencesAppSynchronize(CFSTR(
+                                                          ".GlobalPreferences"));
+                    order_all_windows =
+                        CFPreferencesGetAppBooleanValue(CFSTR(
+                                                            "AppleSpacesSwitchOnActivate"),
+                                                        CFSTR(
+                                                            ".GlobalPreferences"),
+                                                        &ok);
+                    if (!ok)
+                        order_all_windows = YES;
                 }
 
                 /* TODO: In the workspaces && !AppleSpacesSwitchOnActivate case, the windows are ordered
@@ -445,7 +527,8 @@ - (void) sendEvent:(NSEvent *)e
                  *       be restoring one of them.
                  */
                 if ([e data2] & 0x10) {         // 0x10 (bfCPSOrderAllWindowsForward) is set when we use cmd-tab or the dock icon
-                    DarwinSendDDXEvent(kXquartzBringAllToFront, 1, order_all_windows);
+                    DarwinSendDDXEvent(kXquartzBringAllToFront, 1,
+                                       order_all_windows);
                 }
             }
             break;
@@ -468,20 +551,32 @@ - (void) sendEvent:(NSEvent *)e
         break;          /* for gcc */
     }
 
-    if (for_appkit) {
-        [super sendEvent:e];
-    }
+    if (for_appkit) [super sendEvent:e];
 
     if (for_x) {
+#ifdef HAVE_LIBDISPATCH
         dispatch_async(eventTranslationQueue, ^{
-            [self sendX11NSEvent:e];
-        });
+                           [self sendX11NSEvent:e];
+                       });
+#else
+        [self sendX11NSEvent:e];
+#endif
     }
 }
 
+- (void) set_window_menu:(NSArray *)list
+{
+    [_controller set_window_menu:list];
+}
+
+- (void) set_window_menu_check:(NSNumber *)n
+{
+    [_controller set_window_menu_check:n];
+}
+
 - (void) set_apps_menu:(NSArray *)list
 {
-    [self.controller set_apps_menu:list];
+    [_controller set_apps_menu:list];
 }
 
 - (void) set_front_process:unused
@@ -492,6 +587,16 @@ - (void) set_front_process:unused
         [self activateX:YES];
 }
 
+- (void) set_can_quit:(NSNumber *)state
+{
+    [_controller set_can_quit:[state boolValue]];
+}
+
+- (void) server_ready:unused
+{
+    [_controller server_ready];
+}
+
 - (void) show_hide_menubar:(NSNumber *)state
 {
     /* Also shows/hides the dock */
@@ -504,53 +609,407 @@ - (void) show_hide_menubar:(NSNumber *)state
 
 - (void) launch_client:(NSString *)cmd
 {
-    (void)[self.controller application:self openFile:cmd];
+    (void)[_controller application:self openFile:cmd];
 }
 
+/* user preferences */
 
-- (void) read_defaults
+/* Note that these functions only work for arrays whose elements
+   can be toll-free-bridged between NS and CF worlds. */
+
+static const void *
+cfretain(CFAllocatorRef a, const void *b)
 {
-    NSUserDefaults * const defaults = NSUserDefaults.xquartzDefaults;
+    return CFRetain(b);
+}
 
-    XQuartzRootlessDefault = [defaults boolForKey:XQuartzPrefKeyRootless];
-    XQuartzFullscreenMenu = [defaults boolForKey:XQuartzPrefKeyFullscreenMenu];
-    XQuartzFullscreenDisableHotkeys = ![defaults boolForKey:XQuartzPrefKeyFullscreenHotkeys];
+static void
+cfrelease(CFAllocatorRef a, const void *b)
+{
+    CFRelease(b);
+}
 
-    darwinFakeButtons = [defaults boolForKey:XQuartzPrefKeyFakeButtons];
-    XQuartzOptionSendsAlt = [defaults boolForKey:XQuartzPrefKeyOptionSendsAlt];
+CF_RETURNS_RETAINED
+static CFMutableArrayRef
+nsarray_to_cfarray(NSArray *in)
+{
+    CFMutableArrayRef out;
+    CFArrayCallBacks cb;
+    NSObject *ns;
+    const CFTypeRef *cf;
+    int i, count;
 
-    if (darwinFakeButtons) {
-        NSString * const fake2 = [defaults stringForKey:XQuartzPrefKeyFakeButton2];
-        if (fake2) {
-            darwinFakeMouse2Mask = DarwinParseModifierList(fake2.UTF8String, TRUE);
+    memset(&cb, 0, sizeof(cb));
+    cb.version = 0;
+    cb.retain = cfretain;
+    cb.release = cfrelease;
+
+    count = [in count];
+    out = CFArrayCreateMutable(NULL, count, &cb);
+
+    for (i = 0; i < count; i++) {
+        ns = [in objectAtIndex:i];
+
+        if ([ns isKindOfClass:[NSArray class]])
+            cf = (CFTypeRef)nsarray_to_cfarray((NSArray *)ns);
+        else
+            cf = CFRetain((CFTypeRef)ns);
+
+        CFArrayAppendValue(out, cf);
+        CFRelease(cf);
+    }
+
+    return out;
+}
+
+static NSMutableArray *
+cfarray_to_nsarray(CFArrayRef in)
+{
+    NSMutableArray *out;
+    const CFTypeRef *cf;
+    NSObject *ns;
+    int i, count;
+
+    count = CFArrayGetCount(in);
+    out = [[NSMutableArray alloc] initWithCapacity:count];
+
+    for (i = 0; i < count; i++) {
+        cf = CFArrayGetValueAtIndex(in, i);
+
+        if (CFGetTypeID(cf) == CFArrayGetTypeID())
+            ns = cfarray_to_nsarray((CFArrayRef)cf);
+        else
+            ns = [(id) cf retain];
+
+        [out addObject:ns];
+        [ns release];
+    }
+
+    return out;
+}
+
+- (CFPropertyListRef) prefs_get_copy:(NSString *)key
+{
+    CFPropertyListRef value;
+
+    value = CFPreferencesCopyAppValue((CFStringRef)key,
+                                      app_prefs_domain_cfstr);
+
+    if (value == NULL) {
+        static CFDictionaryRef defaults;
+
+        if (defaults == NULL) {
+            CFStringRef error = NULL;
+            CFDataRef data;
+            CFURLRef url;
+            SInt32 error_code;
+
+            url = (CFURLCreateFromFileSystemRepresentation
+                       (NULL, (unsigned char *)DEFAULTS_FILE,
+                       strlen(DEFAULTS_FILE), false));
+            if (CFURLCreateDataAndPropertiesFromResource(NULL, url, &data,
+                                                         NULL, NULL,
+                                                         &error_code)) {
+                defaults = (CFPropertyListCreateFromXMLData
+                                (NULL, data,
+                                kCFPropertyListMutableContainersAndLeaves,
+                                &error));
+                if (error != NULL) CFRelease(error);
+                CFRelease(data);
+            }
+            CFRelease(url);
+
+            if (defaults != NULL) {
+                NSMutableArray *apps, *elt;
+                int count, i;
+                NSString *name, *nname;
+
+                /* Localize the names in the default apps menu. */
+
+                apps =
+                    [(NSDictionary *) defaults objectForKey:@PREFS_APPSMENU];
+                if (apps != nil) {
+                    count = [apps count];
+                    for (i = 0; i < count; i++) {
+                        elt = [apps objectAtIndex:i];
+                        if (elt != nil &&
+                            [elt isKindOfClass:[NSArray class]]) {
+                            name = [elt objectAtIndex:0];
+                            if (name != nil) {
+                                nname = NSLocalizedString(name, nil);
+                                if (nname != nil && nname != name)
+                                    [elt replaceObjectAtIndex:0 withObject:
+                                     nname];
+                            }
+                        }
+                    }
+                }
+            }
         }
 
-        NSString * const fake3 = [defaults stringForKey:XQuartzPrefKeyFakeButton3];
-        if (fake3) {
-            darwinFakeMouse3Mask = DarwinParseModifierList(fake3.UTF8String, TRUE);
+        if (defaults != NULL) value = CFDictionaryGetValue(defaults, key);
+        if (value != NULL) CFRetain(value);
+    }
+
+    return value;
+}
+
+- (int) prefs_get_integer:(NSString *)key default:(int)def
+{
+    CFPropertyListRef value;
+    int ret;
+
+    value = [self prefs_get_copy:key];
+
+    if (value != NULL && CFGetTypeID(value) == CFNumberGetTypeID())
+        CFNumberGetValue(value, kCFNumberIntType, &ret);
+    else if (value != NULL && CFGetTypeID(value) == CFStringGetTypeID())
+        ret = CFStringGetIntValue(value);
+    else
+        ret = def;
+
+    if (value != NULL) CFRelease(value);
+
+    return ret;
+}
+
+- (const char *) prefs_get_string:(NSString *)key default:(const char *)def
+{
+    CFPropertyListRef value;
+    const char *ret = NULL;
+
+    value = [self prefs_get_copy:key];
+
+    if (value != NULL && CFGetTypeID(value) == CFStringGetTypeID()) {
+        NSString *s = (NSString *)value;
+
+        ret = [s UTF8String];
+    }
+
+    if (value != NULL) CFRelease(value);
+
+    return ret != NULL ? ret : def;
+}
+
+- (NSURL *) prefs_copy_url:(NSString *)key default:(NSURL *)def
+{
+    CFPropertyListRef value;
+    NSURL *ret = NULL;
+
+    value = [self prefs_get_copy:key];
+
+    if (value != NULL && CFGetTypeID(value) == CFStringGetTypeID()) {
+        NSString *s = (NSString *)value;
+
+        ret = [NSURL URLWithString:s];
+        [ret retain];
+    }
+
+    if (value != NULL) CFRelease(value);
+
+    return ret != NULL ? ret : def;
+}
+
+- (float) prefs_get_float:(NSString *)key default:(float)def
+{
+    CFPropertyListRef value;
+    float ret = def;
+
+    value = [self prefs_get_copy:key];
+
+    if (value != NULL
+        && CFGetTypeID(value) == CFNumberGetTypeID()
+        && CFNumberIsFloatType(value))
+        CFNumberGetValue(value, kCFNumberFloatType, &ret);
+    else if (value != NULL && CFGetTypeID(value) == CFStringGetTypeID())
+        ret = CFStringGetDoubleValue(value);
+
+    if (value != NULL) CFRelease(value);
+
+    return ret;
+}
+
+- (int) prefs_get_boolean:(NSString *)key default:(int)def
+{
+    CFPropertyListRef value;
+    int ret = def;
+
+    value = [self prefs_get_copy:key];
+
+    if (value != NULL) {
+        if (CFGetTypeID(value) == CFNumberGetTypeID())
+            CFNumberGetValue(value, kCFNumberIntType, &ret);
+        else if (CFGetTypeID(value) == CFBooleanGetTypeID())
+            ret = CFBooleanGetValue(value);
+        else if (CFGetTypeID(value) == CFStringGetTypeID()) {
+            const char *tem = [(NSString *) value UTF8String];
+            if (strcasecmp(tem, "true") == 0 || strcasecmp(tem, "yes") == 0)
+                ret = YES;
+            else
+                ret = NO;
         }
+
+        CFRelease(value);
     }
+    return ret;
+}
 
-    NSString * const appKitModifiers = [defaults stringForKey:XQuartzPrefKeyAppKitModifiers];
-    if (appKitModifiers) {
-        darwinAppKitModMask = DarwinParseModifierList(appKitModifiers.UTF8String, TRUE);
+- (NSArray *) prefs_get_array:(NSString *)key
+{
+    NSArray *ret = nil;
+    CFPropertyListRef value;
+
+    value = [self prefs_get_copy:key];
+
+    if (value != NULL) {
+        if (CFGetTypeID(value) == CFArrayGetTypeID())
+            ret = [cfarray_to_nsarray (value)autorelease];
+
+        CFRelease(value);
     }
 
-    NSString * const windowItemModifiers = [defaults stringForKey:XQuartzPrefKeyWindowItemModifiers];
-    if (windowItemModifiers) {
-        windowItemModMask = DarwinParseModifierList(windowItemModifiers.UTF8String, FALSE);
+    return ret;
+}
+
+- (void) prefs_set_integer:(NSString *)key value:(int)value
+{
+    CFNumberRef x;
+
+    x = CFNumberCreate(NULL, kCFNumberIntType, &value);
+
+    CFPreferencesSetValue((CFStringRef)key, (CFTypeRef)x,
+                          app_prefs_domain_cfstr,
+                          kCFPreferencesCurrentUser,
+                          kCFPreferencesAnyHost);
+
+    CFRelease(x);
+}
+
+- (void) prefs_set_float:(NSString *)key value:(float)value
+{
+    CFNumberRef x;
+
+    x = CFNumberCreate(NULL, kCFNumberFloatType, &value);
+
+    CFPreferencesSetValue((CFStringRef)key, (CFTypeRef)x,
+                          app_prefs_domain_cfstr,
+                          kCFPreferencesCurrentUser,
+                          kCFPreferencesAnyHost);
+
+    CFRelease(x);
+}
+
+- (void) prefs_set_boolean:(NSString *)key value:(int)value
+{
+    CFPreferencesSetValue(
+        (CFStringRef)key,
+        (CFTypeRef)(value ? kCFBooleanTrue
+                    : kCFBooleanFalse),
+        app_prefs_domain_cfstr,
+        kCFPreferencesCurrentUser, kCFPreferencesAnyHost);
+
+}
+
+- (void) prefs_set_array:(NSString *)key value:(NSArray *)value
+{
+    CFArrayRef cfarray;
+
+    cfarray = nsarray_to_cfarray(value);
+    CFPreferencesSetValue((CFStringRef)key,
+                          (CFTypeRef)cfarray,
+                          app_prefs_domain_cfstr,
+                          kCFPreferencesCurrentUser, kCFPreferencesAnyHost);
+    CFRelease(cfarray);
+}
+
+- (void) prefs_set_string:(NSString *)key value:(NSString *)value
+{
+    CFPreferencesSetValue((CFStringRef)key, (CFTypeRef)value,
+                          app_prefs_domain_cfstr, kCFPreferencesCurrentUser,
+                          kCFPreferencesAnyHost);
+}
+
+- (void) prefs_synchronize
+{
+    CFPreferencesAppSynchronize(kCFPreferencesCurrentApplication);
+}
+
+- (void) read_defaults
+{
+    NSString *nsstr;
+    const char *tem;
+
+    XQuartzRootlessDefault = [self prefs_get_boolean:@PREFS_ROOTLESS
+                              default               :XQuartzRootlessDefault];
+    XQuartzFullscreenMenu = [self prefs_get_boolean:@PREFS_FULLSCREEN_MENU
+                             default               :XQuartzFullscreenMenu];
+    XQuartzFullscreenDisableHotkeys =
+        ![self prefs_get_boolean:@PREFS_FULLSCREEN_HOTKEYS
+          default               :!
+          XQuartzFullscreenDisableHotkeys];
+    darwinFakeButtons = [self prefs_get_boolean:@PREFS_FAKEBUTTONS
+                         default               :darwinFakeButtons];
+    XQuartzOptionSendsAlt = [self prefs_get_boolean:@PREFS_OPTION_SENDS_ALT
+                             default               :XQuartzOptionSendsAlt];
+
+    if (darwinFakeButtons) {
+        const char *fake2, *fake3;
+
+        fake2 = [self prefs_get_string:@PREFS_FAKE_BUTTON2 default:NULL];
+        fake3 = [self prefs_get_string:@PREFS_FAKE_BUTTON3 default:NULL];
+
+        if (fake2 != NULL) darwinFakeMouse2Mask = DarwinParseModifierList(
+                fake2, TRUE);
+        if (fake3 != NULL) darwinFakeMouse3Mask = DarwinParseModifierList(
+                fake3, TRUE);
+    }
+
+    tem = [self prefs_get_string:@PREFS_APPKIT_MODIFIERS default:NULL];
+    if (tem != NULL) darwinAppKitModMask = DarwinParseModifierList(tem, TRUE);
+
+    tem = [self prefs_get_string:@PREFS_WINDOW_ITEM_MODIFIERS default:NULL];
+    if (tem != NULL) {
+        windowItemModMask = DarwinParseModifierList(tem, FALSE);
+    }
+    else {
+        nsstr = NSLocalizedString(@"window item modifiers",
+                                  @"window item modifiers");
+        if (nsstr != NULL) {
+            tem = [nsstr UTF8String];
+            if ((tem != NULL) && strcmp(tem, "window item modifiers")) {
+                windowItemModMask = DarwinParseModifierList(tem, FALSE);
+            }
+        }
     }
 
-    XQuartzEnableKeyEquivalents = [defaults boolForKey:XQuartzPrefKeyKeyEquivs];
+    XQuartzEnableKeyEquivalents = [self prefs_get_boolean:@PREFS_KEYEQUIVS
+                                   default               :
+                                   XQuartzEnableKeyEquivalents];
+
+    darwinSyncKeymap = [self prefs_get_boolean:@PREFS_SYNC_KEYMAP
+                        default               :darwinSyncKeymap];
 
-    darwinSyncKeymap = [defaults boolForKey:XQuartzPrefKeySyncKeymap];
+    darwinDesiredDepth = [self prefs_get_integer:@PREFS_DEPTH
+                          default               :darwinDesiredDepth];
 
-    darwinDesiredDepth = [defaults integerForKey:XQuartzPrefKeyDepth];
+    noTestExtensions = ![self prefs_get_boolean:@PREFS_TEST_EXTENSIONS
+                         default               :FALSE];
 
-    noTestExtensions = ![defaults boolForKey:XQuartzPrefKeyTESTExtension];
-    noRenderExtension = ![defaults boolForKey:XQuartzPrefKeyRENDERExtension];
+    noRenderExtension = ![self prefs_get_boolean:@PREFS_RENDER_EXTENSION
+                          default               :TRUE];
 
-    XQuartzScrollInDeviceDirection = [defaults boolForKey:XQuartzPrefKeyScrollInDeviceDirection];
+    XQuartzScrollInDeviceDirection =
+        [self prefs_get_boolean:@PREFS_SCROLL_IN_DEV_DIRECTION
+         default               :
+         XQuartzScrollInDeviceDirection];
+
+#if XQUARTZ_SPARKLE
+    NSURL *url = [self prefs_copy_url:@PREFS_UPDATE_FEED default:nil];
+    if (url) {
+        [[SUUpdater sharedUpdater] setFeedURL:url];
+        [url release];
+    }
+#endif
 }
 
 /* This will end up at the end of the responder chain. */
@@ -560,83 +1019,123 @@ - (void) copy:sender
                        AppleWMCopyToPasteboard);
 }
 
+- (X11Controller *) controller
+{
+    return _controller;
+}
+
+- (OSX_BOOL) x_active
+{
+    return _x_active;
+}
+
 @end
 
-void
-X11ApplicationSetWindowMenu(int nitems, const char **items,
-                            const char *shortcuts)
+static NSArray *
+array_with_strings_and_numbers(int nitems, const char **items,
+                               const char *numbers)
 {
-    @autoreleasepool {
-        NSMutableArray <NSArray <NSString *> *> * const allMenuItems = [NSMutableArray array];
+    NSMutableArray *array, *subarray;
+    NSString *string, *number;
+    int i;
 
-        for (int i = 0; i < nitems; i++) {
-            NSMutableArray <NSString *> * const menuItem = [NSMutableArray array];
-            [menuItem addObject:@(items[i])];
+    /* (Can't autorelease on the X server thread) */
 
-            if (shortcuts[i] == 0) {
-                [menuItem addObject:@""];
-            } else {
-                [menuItem addObject:[NSString stringWithFormat:@"%d", shortcuts[i]]];
-            }
+    array = [[NSMutableArray alloc] initWithCapacity:nitems];
+
+    for (i = 0; i < nitems; i++) {
+        subarray = [[NSMutableArray alloc] initWithCapacity:2];
+
+        string = [[NSString alloc] initWithUTF8String:items[i]];
+        [subarray addObject:string];
+        [string release];
 
-            [allMenuItems addObject:menuItem];
+        if (numbers[i] != 0) {
+            number = [[NSString alloc] initWithFormat:@"%d", numbers[i]];
+            [subarray addObject:number];
+            [number release];
         }
+        else
+            [subarray addObject:@""];
 
-        dispatch_async(dispatch_get_main_queue(), ^{
-            [X11App.controller set_window_menu:allMenuItems];
-        });
+        [array addObject:subarray];
+        [subarray release];
     }
+
+    return array;
+}
+
+void
+X11ApplicationSetWindowMenu(int nitems, const char **items,
+                            const char *shortcuts)
+{
+    NSArray *array;
+    array = array_with_strings_and_numbers(nitems, items, shortcuts);
+
+    /* Send the array of strings over to the appkit thread */
+
+    message_kit_thread(@selector (set_window_menu:), array);
+    [array release];
 }
 
 void
 X11ApplicationSetWindowMenuCheck(int idx)
 {
-    dispatch_async(dispatch_get_main_queue(), ^{
-        [X11App.controller set_window_menu_check:@(idx)];
-    });
+    NSNumber *n;
+
+    n = [[NSNumber alloc] initWithInt:idx];
+
+    message_kit_thread(@selector (set_window_menu_check:), n);
+
+    [n release];
 }
 
 void
 X11ApplicationSetFrontProcess(void)
 {
-    dispatch_async(dispatch_get_main_queue(), ^{
-        [X11App set_front_process:nil];
-    });
+    message_kit_thread(@selector (set_front_process:), nil);
 }
 
 void
 X11ApplicationSetCanQuit(int state)
 {
-    dispatch_async(dispatch_get_main_queue(), ^{
-        X11App.controller.can_quit = !!state;
-    });
+    NSNumber *n;
+
+    n = [[NSNumber alloc] initWithBool:state];
+
+    message_kit_thread(@selector (set_can_quit:), n);
+
+    [n release];
 }
 
 void
 X11ApplicationServerReady(void)
 {
-    dispatch_async(dispatch_get_main_queue(), ^{
-        [X11App.controller server_ready];
-    });
+    message_kit_thread(@selector (server_ready:), nil);
 }
 
 void
 X11ApplicationShowHideMenubar(int state)
 {
-    dispatch_async(dispatch_get_main_queue(), ^{
-        [X11App show_hide_menubar:@(state)];
-    });
+    NSNumber *n;
+
+    n = [[NSNumber alloc] initWithBool:state];
+
+    message_kit_thread(@selector (show_hide_menubar:), n);
+
+    [n release];
 }
 
 void
 X11ApplicationLaunchClient(const char *cmd)
 {
-    @autoreleasepool {
-        NSString *string = @(cmd);
-        dispatch_async(dispatch_get_main_queue(), ^{
-            [X11App launch_client:string];
-        });
-    }
+    NSString *string;
+
+    string = [[NSString alloc] initWithUTF8String:cmd];
+
+    message_kit_thread(@selector (launch_client:), string);
+
+    [string release];
 }
 
 /* This is a special function in that it is run from the *SERVER* thread and
@@ -647,9 +1146,8 @@ - (void) copy:sender
 X11ApplicationCanEnterRandR(void)
 {
     NSString *title, *msg;
-    NSUserDefaults * const defaults = NSUserDefaults.xquartzDefaults;
 
-    if ([defaults boolForKey:XQuartzPrefKeyNoRANDRAlert] ||
+    if ([X11App prefs_get_boolean:@PREFS_NO_RANDR_ALERT default:NO] ||
         XQuartzShieldingWindowLevel != 0)
         return TRUE;
 
@@ -662,17 +1160,15 @@ - (void) copy:sender
     if (!XQuartzIsRootless)
         QuartzShowFullscreen(FALSE);
 
-    NSInteger __block alert_result;
-    dispatch_sync(dispatch_get_main_queue(), ^{
-        alert_result = NSRunAlertPanel(title, @"%@",
-                                       NSLocalizedString(@"Allow", @""),
-                                       NSLocalizedString(@"Cancel", @""),
-                                       NSLocalizedString(@"Always Allow", @""), msg);
-    });
-
-    switch (alert_result) {
+    switch (NSRunAlertPanel(title, @"%@",
+                            NSLocalizedString(@"Allow",
+                                              @""),
+                            NSLocalizedString(@"Cancel",
+                                              @""),
+                            NSLocalizedString(@"Always Allow", @""), msg)) {
     case NSAlertOtherReturn:
-        [defaults setBool:YES forKey:XQuartzPrefKeyNoRANDRAlert];
+        [X11App prefs_set_boolean:@PREFS_NO_RANDR_ALERT value:YES];
+        [X11App prefs_synchronize];
 
     case NSAlertDefaultReturn:
         return YES;
@@ -687,9 +1183,8 @@ - (void) copy:sender
 {
     char *tem, buf[1024];
     NSString *msg;
-    NSUserDefaults * const defaults = NSUserDefaults.xquartzDefaults;
 
-    if ([defaults boolForKey:XQuartzPrefKeyDoneXinitCheck])
+    if ([X11App prefs_get_boolean:@PREFS_DONE_XINIT_CHECK default:NO])
         return;
 
     tem = getenv("HOME");
@@ -723,7 +1218,8 @@ - (void) copy:sender
     }
 
 done:
-    [defaults setBool:YES forKey:XQuartzPrefKeyDoneXinitCheck];
+    [X11App prefs_set_boolean:@PREFS_DONE_XINIT_CHECK value:YES];
+    [X11App prefs_synchronize];
 }
 
 static inline pthread_t
@@ -735,9 +1231,6 @@ - (void) copy:sender
     pthread_attr_init(&attr);
     pthread_attr_setscope(&attr, PTHREAD_SCOPE_SYSTEM);
     pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_DETACHED);
-    if (&pthread_attr_set_qos_class_np) {
-        pthread_attr_set_qos_class_np(&attr, QOS_CLASS_USER_INITIATED, 0);
-    }
     pthread_create(&tid, &attr, func, arg);
     pthread_attr_destroy(&attr);
 
